
;--------Unterprogramme zur Nutzung des I2C-----------------------------------
I2C_Wait:							; wait 2ms
	push R17
	push R18
; ============================= 
;   Warteschleifen-Generator 
;     22118 Zyklen:
; ----------------------------- 
; warte 22116 Zyklen:
          ldi  R17, $26
WGL0b:    ldi  R18, $C1
WGL1b:    dec  R18
          brne WGL1b
          dec  R17
          brne WGL0b
; ----------------------------- 
; warte 2 Zyklen:
          nop
          nop
; ============================= 
	pop R18
	pop R17
ret

I2C_Start:
; A change in the state of SDA from high to low, 
; while the clock is high

	sbi		I2C_Port,SDA
	rcall	I2C_Wait

	sbi		I2C_Port,SCL
	rcall	I2C_Wait

	cbi		I2C_Port,SDA
	rcall	I2C_Wait
ret

I2C_Stop:
; A change in the state of SDA from low to high , 
; while the clock is high
	cbi		I2C_Port,SCL
	rcall	I2C_Wait

	cbi		I2C_Port,SDA
	rcall	I2C_Wait

	sbi		I2C_Port,SCL
	rcall	I2C_Wait

	sbi		I2C_Port,SDA
	rcall	I2C_Wait
ret

I2C_Send:
; The state of SDA represents valid data when the SDA is  
; stable for the duration of the high periode of the clock signal.
; The data on the line must be changed during low periode of the clock signal.

	ldi		temp1,7					; bertrage 8 Bits

I2C_Send_weiter:
		cbi		I2C_Port,SCL
		rcall	I2C_Wait
	
		rol		data
		sbi		I2C_Port,SDA
		brcs	I2C_Send_Carry_weiter
		cbi		I2C_Port,SDA
		
I2C_Send_Carry_weiter:
		sbi		I2C_Port,SCL
		rcall	I2C_Wait

		cpi		temp1,0
		breq	I2C_Send_Ende

		dec		temp1

		rjmp	I2C_Send_weiter

I2C_Send_Ende:
ret

I2C_Send_Ack:
	cbi		I2C_Port,SCL
	rcall	I2C_Wait
	
	cbi		I2C_Port,SDA
	
	sbi		I2C_Port,SCL
	rcall	I2C_Wait

	cbi		I2C_Port,SCL
ret

I2C_Send_no_Ack:
	cbi		I2C_Port,SCL
	rcall	I2C_Wait
	
	sbi		I2C_Port,SDA
	
	sbi		I2C_Port,SCL
	rcall	I2C_Wait

	cbi		I2C_Port,SCL
ret

I2C_Read:
	cbi		I2C_Port,SCL	; zuerst (!) SCL auf LOW ...
	rcall	I2C_Wait

	cbi		I2C_DDR,SDA		; ... und erst dann SDA als Eingang
	rcall	I2C_Wait	

	ldi		data,0

	ldi		temp1,7
	
I2C_Read_weiter:
		sbi		I2C_Port,SCL
		rcall	I2C_Wait
		rcall	I2C_Bit_lesen
		cbi		I2C_Port,SCL
		rcall	I2C_Wait

		cpi		temp1,0
		breq	I2C_Read_Ende

		dec		temp1

		rjmp	I2C_Read_weiter

I2C_Read_Ende:

	sbi		I2C_DDR,SDA
	sbi		I2C_Port,SDA
ret

I2C_Bit_lesen:
	clc 					; Carry lschen
	sbic	I2C_PIN,SDA		; skip if bit is cleared
	sec 					; sonst Carry setzen
	rol		data			; rotate left through carry
ret

I2C_Read_Ack:
	cbi		I2C_Port,SCL	; zuerst (!) SCL auf LOW ...
	rcall	I2C_Wait

	cbi		I2C_DDR,SDA		; ... und erst dann SDA als Eingang
	rcall	I2C_Wait

	sbi		I2C_Port,SCL
	rcall	I2C_Wait

	cbi		I2C_Port,SCL	; SCL auf LOW
	rcall	I2C_Wait

	sbi		I2C_DDR,SDA		; SDA wieder als Ausgang
ret
